﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics.Contracts;

namespace PropertyTest
{

    /*
    public class MyClassPublicField
    {

        public int Property;

        public MyClassPublicField()
        {
            Property = 1;
        }

        public int Random()
        {
            int h = Property + 10;
            return new Random().Next(100) + 10;
        }  
    }

    public class MyClassPrivateField
    {

        private int Property;

        public MyClassPrivateField()
        {
            Property = 1;
        }

        public int Random()
        {
            int h = Property + 10;
            Random r = new Random();
            return r.Next(100) + 10;
        }
    }

    public class MyClassPublicProperty
    {
        public int Property { get; set; }

        public MyClassPublicProperty()
        {
            Property = 1;
        }

        public int Random()
        {
            int h = Property + 10;
            return new Random().Next(100) + 10;
        }
    }

    public class MyClassPrivateProperty
    {
        public int Property { get; private set; }

        public MyClassPrivateProperty()
        {
            Property = 1;
        }

        public int Random()
        {
            int h = Property + 10;
            return new Random().Next(100) + 10;
        }
    }
     * */

    /*
    public class MyClassNotAutoGeneratedPublic
    {

        private int property;
        public int Property
        { 
            get { return property; }
            set { property = value; }
        }

        public MyClassNotAutoGeneratedPublic()
        {
            Property = 1;
        }

        public int Random()
        {
            int h = Property + 10;
            return new Random().Next(100) + 10;
        }
    }

    public class MyClassNotAutoGeneratedPrivate
    {

        private int property;
        public int Property
        {
            get { return property; }
            private set { property = value; }
        }

        public MyClassNotAutoGeneratedPrivate()
        {
            Property = 1;
        }

        public int Random()
        {
            int h = Property + 10;
            return new Random().Next(100) + 10;
        }
    }*/

    /*
    public class MyClassNotAutoGeneratedPublicPure
    {

        private int property;
        /// <requires text="this.Property == 0">this.Property == 0</requires>

        [Pure]
        public int Property
        {
            get
            {
                return property;
            }
            set
            {
                Contract.Requires(this.Property == 0); // Daikon            
                property = value;
            }
        }

        public MyClassNotAutoGeneratedPublicPure()
        {
            Property = 1;
        }

        public int Random()
        {
            int h = Property + 10;
            return new Random().Next(100) + 10;
        }
    }

    public class MyClassNotAutoGeneratedPrivatePure
    {

        private int property;
        [Pure]
        private int Property
        {
            get
            {
                return property;
            }
            set
            {
                property = value;
            }
        }

        public MyClassNotAutoGeneratedPrivatePure()
        {
            Property = 1;
        }

        public int Random()
        {
            int h = Property + 10;
            return new Random().Next(100) + 10;
        }
    }
     * */

    public class ReadOnlyTest
    {
        public readonly int foo = 10;

        public ReadOnlyTest()
        {

        }

        public void test()
        {

        }
    }

    public class Program
    {

        static void Main(string[] args)
        {

            ReadOnlyTest r = new ReadOnlyTest();
            r.test();
            r.test();
            r.test();
            /*
            var a = new MyClassPublicField();

            for (int i = 0; i < 10; i++)
            {
                a.Random();
            }

            var aa = new MyClassPrivateField();

            for (int i = 0; i < 10; i++)
            {
                aa.Random();
            }

            var b = new MyClassPublicProperty();

            for (int i = 0; i < 10; i++)
            {
                b.Random();
            }

            var c = new MyClassPrivateProperty();

            for (int i = 0; i < 10; i++)
            {
                c.Random();
            }
             * */

            /*
            var e = new MyClassNotAutoGeneratedPublic();

            for (int i = 0; i < 10; i++)
            {
                e.Random();
            }

            var f = new MyClassNotAutoGeneratedPrivate();

            for (int i = 0; i < 10; i++)
            {
                f.Random();
            }
             * */

            /*
            var g = new MyClassNotAutoGeneratedPublicPure();

            for (int i = 0; i < 10; i++)
            {
                g.Random();
            }

            var h = new MyClassNotAutoGeneratedPrivatePure();

            for (int i = 0; i < 10; i++)
            {
                h.Random();
            }
             * */
        }
    }
}
